<template>
  <div v-if="!notLogged">
    <v-container>
      <v-card class="elevation-4 emailStyle">
        <v-toolbar flat color="white">
          <v-toolbar-title>
            <span class="primary--text"><b>Avaliações</b></span>
          </v-toolbar-title>
          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
          <div class="navTests">
            <v-btn
              :style="
                this.$route.name == `Main`
                  ? 'background: #FFC107 !important; color: #2a0845 !important; border-color: #FFC107'
                  : ''
              "
              outlined
              small
              class="mr-4"
              elevation="0"
              @click="goToInitialPage"
            >
              Avisos
              <v-icon small right class="ml-3">mdi-bell</v-icon>
            </v-btn>
            <v-btn
              v-if="userRole == 'admin'"
              :style="
                this.$route.name == `ManageAreas`
                  ? 'background: #FFC107 !important; color: #2a0845 !important; border-color: #FFC107'
                  : ''
              "
              outlined
              small
              class="mr-4"
              elevation="0"
              @click="goToManageArea"
            >
              Áreas de Conhecimento
              <v-icon small right class="ml-3">mdi-book</v-icon>
            </v-btn>
            <v-btn
              v-if="userRole == 'admin' || userRole == 'teacher'"
              :style="
                this.$route.name == `QuestionBank`
                  ? 'background: #FFC107 !important; color: #2a0845 !important; border-color: #FFC107'
                  : ''
              "
              outlined
              small
              class="mr-4"
              elevation="0"
              @click="goToQuestionBank"
            >
              Banco de Questões
              <v-icon small right class="ml-3">mdi-database</v-icon>
            </v-btn>
            <v-btn
              v-if="userRole == 'teacher'"
              :style="
                this.$route.name == `TestsPage`
                  ? 'background: #FFC107 !important; color: #2a0845 !important; border-color: #FFC107'
                  : ''
              "
              outlined
              small
              class="mr-4"
              elevation="0"
              @click="goToTests"
            >
              Provas
              <v-icon small right class="ml-3">mdi-file-document</v-icon>
            </v-btn>
            <!-- // BOTÃO -> PROVAS PARA ALUNOS E MONITORES -->
            <v-btn
              v-if="userRole == 'student' || userRole == 'monitor'"
              :style="
                this.$route.name == `StudentTests`
                  ? 'background: #FFC107 !important; color: #2a0845 !important; border-color: #FFC107'
                  : ''
              "
              outlined
              small
              class="mr-4"
              elevation="0"
              @click="goToStudentTests"
            >
              {{ userRole == 'monitor' ? 'Provas para Monitorar' : 'Provas' }}
              <v-icon small right class="ml-3">mdi-file-document</v-icon>
            </v-btn>
          </div>
          <v-spacer /><a style="font-size:0.8rem" class="pr-2" @click="logout">Logout</a>
          <!-- <v-select
            style="position:absolute; right: 20px; bottom: 5px; width: 18%"
            prepend-icon="mdi-account-outline"
            v-model="userRole"
            label="Ver como..."
            flat
            hide-no-data
            hide-details
            item-text="name"
            item-value="value"
            :items="roles"
            @input="changeRole"
          ></v-select> -->
        </v-toolbar>
        <!-- Show main content -->
        <section>
          <router-view :userRole="userRole" />
        </section>
      </v-card>
    </v-container>
    <!-- Dialogs -->
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex'

export default {
  name: 'Tests',
  components: {},
  data: () => ({
    actualNav: '',
    roles: [
      { name: 'Administrador', value: 'admin' },
      { name: 'Professor', value: 'teacher' },
      { name: 'Aluno', value: 'student' },
      { name: 'Monitor', value: 'monitor' },
    ],
    userRole: '',
    notLogged: false,
  }),
  computed: {
    ...mapState({
      actionsMap: (state) => state.user.mappedActions,
    }),
  },
  watch: {},
  async created() {
    this.actualNav = this.$route.name

    const ehqAccessKey = await this.$getItem('accessKeyEHQ')
    const ehqAuth = await this.$getItem('authenticationKeyEHQ')
    const user = await this.$getItem('userEHQ')
    if (ehqAccessKey && ehqAuth && user) {
      //já está logado
      this.userRole = user.type
    } else {
      //não está logado
      this.notLogged = true
    }
  },
  beforeUpdate() {
    this.actualNav = this.$route.name
  },
  methods: {
    //Métodos Backend
    //Métodos Frontend
    changeRole(item) {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.goToInitialPage()
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 220)
    },
    goToInitialPage() {
      if (this.actualNav !== 'Main') {
        this.$router.push({ name: 'Main' })
      }
    },
    goToManageArea() {
      if (this.actualNav !== 'ManageAreas') {
        this.$router.push({ name: 'ManageAreas' })
      }
    },
    goToQuestionBank() {
      if (this.actualNav !== 'QuestionBank2') {
        this.$router.push({ name: 'QuestionBank2' })
      }
    },
    goToTests() {
      if (this.actualNav !== 'TestsPage') {
        this.$router.push({ name: 'TestsPage' })
      }
    },
    goToStudentTests() {
      if (this.actualNav !== 'StudentTests') {
        this.$router.push({ name: 'StudentTests' })
      }
    },
    async logout() {
      await this.$removeItem('accessKeyEHQ')
      await this.$removeItem('authenticationKeyEHQ')
      await this.$removeItem('userEHQ')
      this.$router.push({ name: 'Entity' })
    },
  },
}
</script>

<style>
.navTests > .v-btn:hover {
  background: #2a0845 !important;
  color: #fff !important;
  /* background: #e8e8e8 !important;
  color: #2a0845 !important; */
}

.selectedSubArea {
  background: #ffc107 !important;
  color: #2a0845 !important;
  border-color: #ffc107;
}

.ehqTable > .v-icon:hover {
  color: #ffc107 !important;
}

.ehqTable > .v-icon {
  margin-right: 8px;
}

.navQuestions > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}
</style>
